#include "image.h"
#include "mem_arena.h"
#include <stddef.h>
#include <string.h>

Image *create_image(u64 width, u64 height, Pixel *data, Arena *arena) {
  if (!arena) {
    return NULL;
  }

  u64 pixel_count = width * height;
  u64 buf_length = sizeof(Pixel) * pixel_count;
  u64 alloc_size = sizeof(Image) + buf_length;

  Image *img = wapp_mem_arena_alloc(arena, alloc_size);
  if (!img) {
    return NULL;
  }

  img->width = width;
  img->height = height;
  img->pixel_count = pixel_count;
  memcpy(img->data, data, buf_length);

  return img;
}
