#ifdef TIFF_TYPE_LOOKUP
#undef TIFF_TYPE
#define TIFF_TYPE(NAME, ID, VALUE, BYTES) [VALUE] = (TiffFieldType){.name = NAME, .byte_count = BYTES},
#else
#undef TIFF_TYPE
#define TIFF_TYPE(NAME, ID, VALUE, BYTES) ID = VALUE,
#endif /* ifdef TIFF_TYPE_LOOKUP */

TIFF_TYPE("UNSIGNED BYTE"    , TIFF_FIELD_TYPE_BYTE      , 0x0001, 1) // 8-bit unsigned integer
TIFF_TYPE("ASCII"            , TIFF_FIELD_TYPE_ASCII     , 0x0002, 1) // 8-bit byte that contains a 7-bit ASCII code; the last byte must be NUL (binary zero)
TIFF_TYPE("UNSIGNED SHORT"   , TIFF_FIELD_TYPE_SHORT     , 0x0003, 2) // 16-bit (2-byte) unsigned integer
TIFF_TYPE("UNSIGNED LONG"    , TIFF_FIELD_TYPE_LONG      , 0x0004, 4) // 32-bit (4-byte) unsigned integer
TIFF_TYPE("UNSIGNED RATIONAL", TIFF_FIELD_TYPE_RATIONAL  , 0x0005, 8) // Two LONGs: the first represents the numerator of a fraction; the second, the denominator
TIFF_TYPE("SIGNED BYTE"      , TIFF_FIELD_TYPE_SBYTE     , 0x0006, 1) // An 8-bit signed (twos-complement) integer
TIFF_TYPE("UNDEFINED"        , TIFF_FIELD_TYPE_UNDEFINED , 0x0007, 1) // An 8-bit byte that may contain anything, depending on the definition of the field
TIFF_TYPE("SIGNED SHORT"     , TIFF_FIELD_TYPE_SSHORT    , 0x0008, 2) // A 16-bit (2-byte) signed (twos-complement) integer
TIFF_TYPE("SIGNED LONG"      , TIFF_FIELD_TYPE_SLONG     , 0x0009, 4) // A 32-bit (4-byte) signed (twos-complement) integer
TIFF_TYPE("SIGNED RATIONAL"  , TIFF_FIELD_TYPE_SRATIONAL , 0x000a, 8) // Two SLONG’s: the first represents the numerator of a fraction, the second the denominator
TIFF_TYPE("FLOAT"            , TIFF_FIELD_TYPE_FLOAT     , 0x000b, 4) // Single precision (4-byte) IEEE format
TIFF_TYPE("DOUBLE"           , TIFF_FIELD_TYPE_DOUBLE    , 0x000c, 8) // Double precision (8-byte) IEEE format
